function findChild(val, obj, key="id", children="children") {
    if (val === obj[key]) {
      return obj
    } else if (!obj[children]) {
      return undefined
    }
    return  obj[children].map(child => {
        return findChild(val, child, key, children )
      }).filter(child => child !== undefined)[0]
  }

function editChild(val, newObj, obj, key="id", children="children") {
    if (val === obj[key]) return Object.assign({}, newObj)
    if (!obj[children]) return Object.assign({}, obj)
    return Object.assign(obj, {[children]: obj[children].map(child => {
      return editChild(val, newObj, child, key, children, child)})})
}

function deleteChild(val, obj, key="id", children="children", depth=0) {
  depth === 0 && obj[key] === val && topLevelError()
  --depth
  if (!obj[children]) return Object.assign({}, obj)
  const idx = obj[children].map(child => child[key]).indexOf(val)
  const onlyChild = obj[children].length === 1
  if (idx === -1) {
    return Object.assign(obj, {
      [children]: obj[children].map(child => {
        return deleteChild(val, child, key, children, depth)
      })
    })
  }
  return Object.assign(obj, (onlyChild && {[children]: null}) || {
      [children]: obj[children].slice(0, idx).concat(
        obj[children].slice(idx + 1))}
  )

function topLevelError() {
  throw "Cannot delete top level node"
}

module.exports = {findChild, editChild, deleteChild}
